2018hdu杭电多校第三场 hdu6319 Problem A. Ascending Rating(单调队列)

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 2482    Accepted Submission(s): 785

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k


It is guaranteed that 

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :


Note that ``⊕'' denotes binary XOR operation.

Sample Input

1

10 6 10 5 5 5 5

3 2 2 1 5 7 6 8 2 9

Sample Output

46

11

Source

2018 Multi-University Training Contest 3


题意:给出n长度的数组,需要对长度为m的区间进行操作,

求 A 和 B。A、B如右图,maxrating[i] 表示第i个区间的最大值,count[i] 表示第i个区间的最大上升区间的长度。

题解: 这题要用到单调队列,第一次用单调队列。先解释一下什么是单调队列。

单调队列中存的是 一个区间 的最大的一个递减序列的序号

比如数组  a[i]

i 1 2 3 4 5 6 7 8
a[i] 9 4 7 6 8 12 7 9

      

 

 

9加入队列 ,9

4加入队列 ,9 4

7加入队列, 这时要把队尾和7比较 比7小的抛出队列 然后再把7加入 所以是 9 7

6加入队列,9 7 6

8加入队列,9 8

但是我们一般存的是 数组序号。

根据单调队列的原理我们维护最大上升区间的长度需要 倒着for。

代码:

#include 
using namespace std;
#define rep(i,a,n) for (int i=a;i=a;i--)
typedef long long ll;
const ll N = 1e7+5;
int _, n, m, k, p, q, r, mod, a[N], Q[N];
int main() {
    for (scanf("%d", &_); _; _--) {
        scanf("%d%d%d%d%d%d%d", &n, &m, &k, &p, &q, &r, &mod);
        rep (i, 1, n+1) {
            if (i <= k) scanf("%d", &a[i]);
            else a[i] = (1ll * p * a[i-1] + 1ll * q * i + r) % mod;
        }
        ll A = 0, B = 0, head = 1, tail = 0;
        per (i, 1, n+1) {
            while (head <= tail && a[Q[tail]] <= a[i]) tail--;
            Q[++tail] = i;
            while (Q[head] - i >= m) head++;
            if (i <= n-m+1) {
                A += (ll)(a[Q[head]] ^ i);
                B += (ll)((tail - head + 1) ^ i);
            }
        }
        printf("%lld %lld\n", A, B);
    }
}

 

你可能感兴趣的:(题解,2018多校,hdu)